/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static int count = 0;
static void ButtonCB1(), ButtonCB2();

static XtCallbackRec callback_list[] = { /* Declare callback list */
        { ButtonCB1, (XtPointer) 1},
        { ButtonCB2, (XtPointer) 2},
        { NULL,      (XtPointer) NULL}, /* Append NULL entry */
    };

static void ButtonCB1(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    printf("Callback No: %d\n", (int)client_data);
    count++;  /* Count the pressed number */
    if (count >= 5) /* Delete callback funcs when pressed 5 times */
        XtRemoveCallbacks(w, XmNactivateCallback, callback_list);
}

static void ButtonCB2(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    printf("Callback No: %d\n", (int)client_data);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, button;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Callbacks", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    button = XmCreatePushButton(toplevel, "button", al, ac);
    XtManageChild(button);

    /* Register multiple callback functions at once */
    XtAddCallbacks(button, XmNactivateCallback, callback_list);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
